/*
 * Harbor API
 * These APIs provide services for manipulating Harbor project.
 *
 * OpenAPI spec version: 2.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.19
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ImmutableSelector'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ImmutableSelector'));
  } else {
    // Browser globals (root is window)
    if (!root.HarborApi) {
      root.HarborApi = {};
    }
    root.HarborApi.ImmutableRule = factory(root.HarborApi.ApiClient, root.HarborApi.ImmutableSelector);
  }
}(this, function(ApiClient, ImmutableSelector) {
  'use strict';

  /**
   * The ImmutableRule model module.
   * @module model/ImmutableRule
   * @version 2.0
   */

  /**
   * Constructs a new <code>ImmutableRule</code>.
   * @alias module:model/ImmutableRule
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>ImmutableRule</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ImmutableRule} obj Optional instance to populate.
   * @return {module:model/ImmutableRule} The populated <code>ImmutableRule</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('id'))
        obj.id = ApiClient.convertToType(data['id'], 'Number');
      if (data.hasOwnProperty('priority'))
        obj.priority = ApiClient.convertToType(data['priority'], 'Number');
      if (data.hasOwnProperty('disabled'))
        obj.disabled = ApiClient.convertToType(data['disabled'], 'Boolean');
      if (data.hasOwnProperty('action'))
        obj.action = ApiClient.convertToType(data['action'], 'String');
      if (data.hasOwnProperty('template'))
        obj.template = ApiClient.convertToType(data['template'], 'String');
      if (data.hasOwnProperty('params'))
        obj.params = ApiClient.convertToType(data['params'], {'String': Object});
      if (data.hasOwnProperty('tag_selectors'))
        obj.tagSelectors = ApiClient.convertToType(data['tag_selectors'], [ImmutableSelector]);
      if (data.hasOwnProperty('scope_selectors'))
        obj.scopeSelectors = ApiClient.convertToType(data['scope_selectors'], {'String': [ImmutableSelector]});
    }
    return obj;
  }

  /**
   * @member {Number} id
   */
  exports.prototype.id = undefined;

  /**
   * @member {Number} priority
   */
  exports.prototype.priority = undefined;

  /**
   * @member {Boolean} disabled
   */
  exports.prototype.disabled = undefined;

  /**
   * @member {String} action
   */
  exports.prototype.action = undefined;

  /**
   * @member {String} template
   */
  exports.prototype.template = undefined;

  /**
   * @member {Object.<String, Object>} params
   */
  exports.prototype.params = undefined;

  /**
   * @member {Array.<module:model/ImmutableSelector>} tagSelectors
   */
  exports.prototype.tagSelectors = undefined;

  /**
   * @member {Object.<String, Array.<module:model/ImmutableSelector>>} scopeSelectors
   */
  exports.prototype.scopeSelectors = undefined;


  return exports;

}));
